// This source code is licensed under the 3-clause BSD license found
// in the LICENSE file in the root directory of this project.

// Class for generating the dark CKD

#pragma once

#include "processor.h"

namespace spex {

class DarkGen : public Processor
{
public:
    DarkGen(const SPEXSettings& settings, CKD& ckd)
      : Processor { settings, ProcLevel::dark, ckd }
    {}
    ~DarkGen() = default;

protected:
    auto processBatch(const int /*i_batch*/) -> void override;
};

} // namespace spex
