// This source code is licensed under the 3-clause BSD license found
// in the LICENSE file in the root directory of this project.

// Entry point (driver function) for the SPEXone L1A-L1C calibration
// software. It initializes the CKD or starts with an empty CKD if
// none was provided and runs the processing steps. The processing
// steps can include the generation of various CKD steps or applying
// the calibration corrections to images which can be either flight
// data or the calibration measurements themselves.

#pragma once

namespace spex {

class SPEXSettings;

auto driver(SPEXSettings& settings) -> void;

} // namespace spex
