// This source code is licensed under the 3-clause BSD license found
// in the LICENSE file in the root directory of this project.

// Class for generating the field of view (FOV) CKD

#pragma once

#include "processor.h"

namespace spex {

class FovGen : public Processor
{
public:
    FovGen(const SPEXSettings& settings, CKD& ckd)
      : Processor { settings, ProcLevel::fov, ckd }
    {}
    ~FovGen() = default;

protected:
    auto processInit() -> void override;
    // Distribute L1A products into batches by viewports
    auto prepareBatches() -> void override;
    auto processBatch(const int i_vp) -> void override;
    // By this point we know the number of L1B ACT angles. Shrink
    // arrays to their optimal sizes.
    auto processFinalize() -> void override;
};

} // namespace spex
