// This source code is licensed under the 3-clause BSD license found
// in the LICENSE file in the root directory of this project.

#pragma once

#include "processor.h"

namespace spex {

class L1C : public Processor
{
public:
    L1C(const SPEXSettings& settings, CKD& ckd)
      : Processor { settings, ProcLevel::l1c, ckd }
    {}

protected:
    // This process has no loop over images. The initialization
    // function is the whole algorithm.
    auto processInit() -> void override;
    // The batch is absent because there are no L1A files
    auto prepareBatches() -> void override {}
};

} // namespace spex
