// This source code is licensed under the 3-clause BSD license found
// in the LICENSE file in the root directory of this project.

// Class for generating the noise CKD

#pragma once

#include "processor.h"

namespace spex {

class NoiseGen : public Processor
{
public:
    NoiseGen(const SPEXSettings& settings, CKD& ckd)
      : Processor { settings, ProcLevel::noise, ckd }
    {}
    ~NoiseGen() = default;

protected:
    auto processInit() -> void override;
    // Each image is in its own batch
    auto prepareBatches() -> void override;
    auto processBatch(const int i_img) -> void override;
    auto processFinalize() -> void override;

private:
    std::vector<double> averages {};
    std::vector<double> sigmas {}; // standard deviations
};

} // namespace spex
