// This source code is licensed under the 3-clause BSD license found
// in the LICENSE file in the root directory of this project.

// Class for generating the radiometric CKD

#pragma once

#include "processor.h"

namespace spex {

class CKD;

class RadGen : public Processor
{
public:
    RadGen(const SPEXSettings& settings, CKD& ckd)
      : Processor { settings, ProcLevel::rad, ckd }
    {}
    ~RadGen() = default;

protected:
    auto processInit() -> void override;
    // Distribute L1A products into batches by viewports
    auto prepareBatches() -> void override;
    auto processBatch(const int i_vp) -> void override;
};

} // namespace spex
