// This source code is licensed under the 3-clause BSD license found
// in the LICENSE file in the root directory of this project.

// Function to read the solar spectrum from the file
// https://lasp.colorado.edu/lisird/resources/lasp/hsrs/v2/
// hybrid_reference_spectrum_p1nm_resolution_c2022-11-30_with_unc.nc.
//
// The wavelengths and spectral values (W m-2 um-1) are saved in two
// arrays for easy manipulation.

#include <string>
#include <vector>

auto readSolarSpectrum(const std::string& filename,
                       std::vector<double>& wavelengths,
                       std::vector<double>& spectrum) -> void;
