// Generation of PRNU CKD

#include "testing.h"

#include <spexone_cal/ckd.h>
#include <spexone_cal/driver.h>
#include <spexone_cal/spex_settings.h>

using Catch::Matchers::WithinAbs;

TEST_CASE("PRNU")
{
    // Main run
    spex::SPEXSettings settings { CMAKE_CURRENT_BINARY_DIR "/prnu_gen.yaml" };
    settings.init();
    spex::driver(settings);

    // Read the generated CKD
    settings.main.ckd_file_in = settings.main.ckd_file_out.c_str();
    spex::CKD ckd { spex::ProcLevel::n_levels, settings };

    // Read the reference CKD
    settings.main.ckd_file_in = TEST_DATA_DIR "/prnu_gen/ckd_ref.nc";
    spex::CKD ckd_ref { spex::ProcLevel::n_levels, settings };

    CHECK(std::ranges::equal(ckd.pixel_mask, ckd_ref.pixel_mask));
    CHECK_THAT(mae(ckd.prnu.prnu, ckd_ref.prnu.prnu), WithinAbs(0.0, 1e-14));
    CHECK_THAT(mae(ckd.prnu.sensitivity_fit, ckd_ref.prnu.sensitivity_fit),
               WithinAbs(0.0, 1e-14));
}
